/*******************************************************************************
 * RP6 C-Control PRO M128 Erweiterungsmodul
 * ----------------------------------------------------------------------------
 * Beeper Beispielprogramm
 * ----------------------------------------------------------------------------
 * Dieses Programm basiert auf einem der anderen CCPRO Beispielprogramme und
 * spielt zwei Melodien in einer Endlosschleife mit dem Piezo Tongeber ab.
 *
 * *****************************************************************************
 * Der Roboter bewegt sich in diesem Beispielprogramm NICHT und kann
 * am Rechner angeschlossen bleiben!
 ******************************************************************************/


// WICHTIG: Immer die RP6CCLib mit einbinden:
#include "../../RP6CCLib/RP6CCLib.cc"


//------------------------------------------------------------------------------
// Tonhhen definieren:

// 1. Oktave
#define Tone_C1     440     //261Hz
#define Tone_Cis1   413     //277Hz
#define Tone_D1     392     //293Hz
#define Tone_Dis1   371     //311Hz
#define Tone_E1     350     //329Hz
#define Tone_F1     330     //349Hz
#define Tone_Fis1   312     //369Hz
#define Tone_G1     294     //392Hz
#define Tone_Gis1   277     //415Hz
#define Tone_A1     262     //440Hz
#define Tone_Ais1   247     //466Hz
#define Tone_H1     234     //493Hz

// 2. Oktave
#define Tone_C2     220     //523Hz
#define Tone_Cis2   208     //554Hz
#define Tone_D2     196     //587Hz
#define Tone_Dis2   185     //622Hz
#define Tone_E2     175     //659Hz
#define Tone_F2     165     //698Hz
#define Tone_Fis2   156     //739Hz
#define Tone_G2     147     //784Hz
#define Tone_Gis2   138     //830Hz
#define Tone_A2     131     //880Hz
#define Tone_Ais2   125     //932Hz
#define Tone_H2     117     //987Hz

// Einige verschiedene Zeiten:
#define T_g     1500
#define T_h     T_g/2
#define T_v     T_g/4
#define T_a     T_g/8
#define T_s     T_g/16
#define T_z     T_g/32


//------------------------------------------------------------------------------
// In den folgenden beiden Routinen werden einfach der Reihe 
// nach bestimmte Tne mit dem Piezo Tongeber erzeugt. 

void pink_panther(void)
{
    tone(Tone_Dis1,T_a);
    tone(Tone_E1,T_a);
    AbsDelay(T_v);

    tone(Tone_Fis1,T_a);
    AbsDelay(T_v);

    tone(Tone_Dis1,T_a);
    tone(Tone_E1,T_a);
    AbsDelay(T_s);

    tone(Tone_Fis1,T_a);
    tone(Tone_G1,T_a);
    AbsDelay(T_s);

    tone(Tone_C2,T_a);
    tone(Tone_H1,T_a);
    AbsDelay(T_s);

    tone(Tone_Dis1,T_a);
    tone(Tone_E1,T_a);
    AbsDelay(T_s);

    tone(Tone_H1,T_a);
    tone(Tone_Ais1,T_h);
    AbsDelay(T_h);

    tone(Tone_A1,T_s);
    tone(Tone_G1,T_s);
    tone(Tone_E1,T_s);
    tone(Tone_D1,T_s);
    tone(Tone_E1,T_h);
    AbsDelay(T_g);

    tone(Tone_E2,T_v);
    tone(Tone_D1,T_a);
    tone(Tone_H1,T_v);
    tone(Tone_A1,T_a);
    tone(Tone_H1,T_v);
    tone(Tone_E1,T_a);
    tone(Tone_H1,T_s);
    tone(Tone_Ais1,T_v);
    tone(Tone_H1,T_s);
    tone(Tone_Ais1,T_v);
    tone(Tone_H1,T_s);
    tone(Tone_Ais1,T_v);
    tone(Tone_H1,T_s);
    tone(Tone_Ais1,T_v);
    tone(Tone_G1,T_a);
    tone(Tone_E1,T_a);
    tone(Tone_D1,T_a);
    tone(Tone_E1,T_v);
    tone(Tone_E1,T_h);
    sound_off();
    AbsDelay(T_h);
}

void good_bad_ugly(void)
{
    tone(Tone_A1,T_a);
    tone(Tone_D2,T_a);
    tone(Tone_A1,T_a);
    tone(Tone_D2,T_a);
    tone(Tone_A1,T_h);
    AbsDelay(T_h);

    tone(Tone_F1,T_h);
    tone(Tone_G1,T_h);
    tone(Tone_D1,T_h);
    AbsDelay(T_g);

    tone(Tone_A1,T_a);
    tone(Tone_D2,T_a);
    tone(Tone_A1,T_a);
    tone(Tone_D2,T_a);
    tone(Tone_A1,T_h);
    AbsDelay(T_h);

    tone(Tone_F1,T_h);
    tone(Tone_G1,T_h);
    tone(Tone_C2,T_h);
    AbsDelay(T_g);

    tone(Tone_A1,T_a);
    tone(Tone_D2,T_a);
    tone(Tone_A1,T_a);
    tone(Tone_D2,T_h);
    AbsDelay(T_h);

    tone(Tone_F1,T_h);
    tone(Tone_E1,T_v);
    tone(Tone_D1,T_v);
    tone(Tone_C1,T_h);
    AbsDelay(T_g);

    tone(Tone_A1,T_a);
    tone(Tone_D2,T_a);
    tone(Tone_A1,T_a);
    tone(Tone_D2,T_a);
    tone(Tone_A1,T_h);
    AbsDelay(T_h);

    tone(Tone_G1,T_h);
    tone(Tone_D1,T_h);
    Timer_T1Stop();
    AbsDelay(T_g);
}

void main(void)
{
	RP6_CCPRO_Init(); // Auf Startsignal warten!

    newline();
    println("  Sound generation program! ");
    newline();

    showScreenLCD("Sound generation", "DEMO Program");
    AbsDelay(2000);
    showScreenLCD("...", "");

    beep(200, 300, 200);
    beep(150, 200, 100);
    beep(120, 100, 100);
    beep(90, 50, 100);
    setLEDs(LED1);

    // Natrlich wollen wir uns das immer und immer wieder anhren ;-) ...
    while(true)  // ... also kommt eine Endlosschleife drum!
    {
        AbsDelay(2000); // 2 Sekunden Pause
        showScreenLCD("The good the bad", "and the ugly");
        setLEDs(LED2 | LED4);

        println(" 1) The good the bad and the ugly...");
        newline();
        good_bad_ugly(); // Melodie abspielen

        setLEDs(LED1 | LED2 | LED3);

        AbsDelay(2000);
        showScreenLCD("Pink", "Panther");
        println(" 2) Pink Panther...");
        pink_panther(); // Melodie abspielen

    }
}


