//------------------------------------------------------------------------------
// Fast unkommentierte Version von Beeper.cc - die Tonhhen sind noch da

#include "../../RP6CCLib/RP6CCLib.cc"

#define Tone_C1     440     //261Hz
#define Tone_Cis1   413     //277Hz
#define Tone_D1     392     //293Hz
#define Tone_Dis1   371     //311Hz
#define Tone_E1     350     //329Hz
#define Tone_F1     330     //349Hz
#define Tone_Fis1   312     //369Hz
#define Tone_G1     294     //392Hz
#define Tone_Gis1   277     //415Hz
#define Tone_A1     262     //440Hz
#define Tone_Ais1   247     //466Hz
#define Tone_H1     234     //493Hz

#define Tone_C2     220     //523Hz
#define Tone_Cis2   208     //554Hz
#define Tone_D2     196     //587Hz
#define Tone_Dis2   185     //622Hz
#define Tone_E2     175     //659Hz
#define Tone_F2     165     //698Hz
#define Tone_Fis2   156     //739Hz
#define Tone_G2     147     //784Hz
#define Tone_Gis2   138     //830Hz
#define Tone_A2     131     //880Hz
#define Tone_Ais2   125     //932Hz
#define Tone_H2     117     //987Hz

#define T_g     1500
#define T_h     T_g/2
#define T_v     T_g/4
#define T_a     T_g/8
#define T_s     T_g/16
#define T_z     T_g/32


void pink_panther(void)
{
    tone(Tone_Dis1,T_a);
    tone(Tone_E1,T_a);
    AbsDelay(T_v);

    tone(Tone_Fis1,T_a);
    AbsDelay(T_v);

    tone(Tone_Dis1,T_a);
    tone(Tone_E1,T_a);
    AbsDelay(T_s);

    tone(Tone_Fis1,T_a);
    tone(Tone_G1,T_a);
    AbsDelay(T_s);

    tone(Tone_C2,T_a);
    tone(Tone_H1,T_a);
    AbsDelay(T_s);

    tone(Tone_Dis1,T_a);
    tone(Tone_E1,T_a);
    AbsDelay(T_s);

    tone(Tone_H1,T_a);
    tone(Tone_Ais1,T_h);
    AbsDelay(T_h);

    tone(Tone_A1,T_s);
    tone(Tone_G1,T_s);
    tone(Tone_E1,T_s);
    tone(Tone_D1,T_s);
    tone(Tone_E1,T_h);
    AbsDelay(T_g);

    tone(Tone_E2,T_v);
    tone(Tone_D1,T_a);
    tone(Tone_H1,T_v);
    tone(Tone_A1,T_a);
    tone(Tone_H1,T_v);
    tone(Tone_E1,T_a);
    tone(Tone_H1,T_s);
    tone(Tone_Ais1,T_v);
    tone(Tone_H1,T_s);
    tone(Tone_Ais1,T_v);
    tone(Tone_H1,T_s);
    tone(Tone_Ais1,T_v);
    tone(Tone_H1,T_s);
    tone(Tone_Ais1,T_v);
    tone(Tone_G1,T_a);
    tone(Tone_E1,T_a);
    tone(Tone_D1,T_a);
    tone(Tone_E1,T_v);
    tone(Tone_E1,T_h);
    sound_off();
    AbsDelay(T_h);
}

void good_bad_ugly(void)
{
    tone(Tone_A1,T_a);
    tone(Tone_D2,T_a);
    tone(Tone_A1,T_a);
    tone(Tone_D2,T_a);
    tone(Tone_A1,T_h);
    AbsDelay(T_h);

    tone(Tone_F1,T_h);
    tone(Tone_G1,T_h);
    tone(Tone_D1,T_h);
    AbsDelay(T_g);

    tone(Tone_A1,T_a);
    tone(Tone_D2,T_a);
    tone(Tone_A1,T_a);
    tone(Tone_D2,T_a);
    tone(Tone_A1,T_h);
    AbsDelay(T_h);

    tone(Tone_F1,T_h);
    tone(Tone_G1,T_h);
    tone(Tone_C2,T_h);
    AbsDelay(T_g);

    tone(Tone_A1,T_a);
    tone(Tone_D2,T_a);
    tone(Tone_A1,T_a);
    tone(Tone_D2,T_h);
    AbsDelay(T_h);

    tone(Tone_F1,T_h);
    tone(Tone_E1,T_v);
    tone(Tone_D1,T_v);
    tone(Tone_C1,T_h);
    AbsDelay(T_g);

    tone(Tone_A1,T_a);
    tone(Tone_D2,T_a);
    tone(Tone_A1,T_a);
    tone(Tone_D2,T_a);
    tone(Tone_A1,T_h);
    AbsDelay(T_h);

    tone(Tone_G1,T_h);
    tone(Tone_D1,T_h);
    Timer_T1Stop();
    AbsDelay(T_g);
}

void main(void)
{
	RP6_CCPRO_Init(); 

    newline();
    println("  Sound generation program! ");
    newline();

    showScreenLCD("Sound generation", "DEMO Program");
    AbsDelay(2000);
    showScreenLCD("...", "");

    beep(100, 200, 300);
    beep(300, 200, 100);
    beep(100, 200, 100);

    setLEDs(LED1);

    while(true)  
    {
        AbsDelay(2000); 
        showScreenLCD("The good the bad", "and the ugly");
        setLEDs(LED2 | LED4);

        println(" 1) The good the bad and the ugly...");
        newline();
        good_bad_ugly();

        setLEDs(LED1 | LED2 | LED3);

        AbsDelay(2000);
        showScreenLCD("Pink", "Panther");
        println(" 2) Pink Panther...");
        pink_panther(); 
    }
}


