//------------------------------------------------------------------------------
// Unkommentierte Version von LEDs_IO_Threads.cc

#include "../../RP6CCLib/RP6CCLib.cc"

void blink(void)
{
	while(true)
	{
        Port_WriteBit(PORT_LED1, 0);
        Thread_Delay(25);
        Port_WriteBit(PORT_LED1, 1);
        Thread_Delay(25);
	}
}

void blink2(void)
{
	while(true)
	{
        Port_WriteBit(PORT_LED2, 0);
        Thread_Delay(80);
        Port_WriteBit(PORT_LED2, 1);
        Thread_Delay(20);
	}
}

void beep_1second(void)
{
	while(true)
	{
        beep_t(200,2,100);
	}
}

void read_adcs(void)
{
    byte channel;
    char tmp[16];
    word result;

    channel = 0;
	while(true)
	{
        ADC_Set(ADC_VREF_VCC,channel);
        Thread_Delay(25);
        result = ADC_Read();

        newline();
        print("ADC( ");
        Str_WriteInt(channel,tmp,0);
		Serial_WriteText(0,tmp);
        print(")=");
	    Str_WriteInt(result,tmp,0);
		Serial_WriteText(0,tmp);
        newline();

        channel++;
        if(channel > 7) channel = 0;
	}
}

void press_start(void)
{
    newline();
    println("Press Start Button!");
    newline();

    while(true) {
		 if(!Port_ReadBit(PORT_START)) {
            beep_t(100, 5, 5);
		 	while(!Port_ReadBit(PORT_START))
				Port_WriteBit(PORT_LED2, 1);
            Port_WriteBit(PORT_LED2, 0);
            break;
		 }
	}
    beep_t(100, 5, 1);
    newline();
    println("OK!");
    newline();
}

void main(void)
{
	RP6_CCPRO_Init();

    newline();
    println("   ________________________");
    println("   \\| RP6  ROBOT SYSTEM |/");
    println("    \\_-_-_-_-_-_-_-_-_-_/ ");
    newline();
    println(" I/O & Threads Testprogramm  ");
    newline();

    showScreenLCD("I/O & Threads", "DEMO Program");
    AbsDelay(2000);
    showScreenLCD("...", "");

    setLEDs(LED1);

    beep(100, 200, 300);
    beep(300, 200, 100);
    beep(100, 200, 1);

    Port_WriteBit(PORT_LED2, 0);
	Port_WriteBit(PORT_LED1, 0);

    while(true)
    {
        showScreenLCD("I/O Testprogram", "Press Start!!!");
        press_start(); 
        Thread_Start(1,blink);

        showScreenLCD("Blink 1 active  ", "Press Start!!!");
        press_start();
        Thread_Start(2,blink2);

        showScreenLCD("Blink 2 active  ", "Press Start!!!");
        press_start();
        Thread_Start(3,read_adcs);

        showScreenLCD("ADC read active ", "Press Start!!!");
        press_start();
        Thread_Start(4,beep_1second);

        showScreenLCD("1sec Beep active", "Press Start!!!");
        press_start();
        

        showScreenLCD("Kill Thread     ", "Press Start!!!");

        setCursorPosLCD(0,12);
        writeCharLCD('1');
        press_start();
        Thread_Kill(1);

        setCursorPosLCD(0,12);
        writeCharLCD('2');
        press_start();
        Thread_Kill(2);

        setCursorPosLCD(0,12);
        writeCharLCD('3');
        press_start();
        Thread_Kill(3);

        setCursorPosLCD(0,12);
        writeCharLCD('4');
        press_start();
        Thread_Kill(4);

        Thread_Delay(20);
    }
}


