//------------------------------------------------------------------------------
// Unkommentierte Version von Temperature.cc

#include "../../RP6CCLib/RP6CCLib.cc"

#define TCN75_ADR 0x90

void main(void)
{
	RP6_CCPRO_Init(); 

    newline();
    println("   ________________________");
    println("   \\| RP6  ROBOT SYSTEM |/");
    println("    \\_-_-_-_-_-_-_-_-_-_/ ");
    newline();
    println("   Temperature Measurement Program ");
    newline();

    showScreenLCD("Temp. Sensor", "DEMO Program");
    AbsDelay(2000);

    beep(100, 200, 300);

    showScreenLCD("Temperature:", "        ");

    float temperature;  
    
    while(true)
    {
		TCN75_run(TCN75_ADR, TCN75A_CONFIG_RES_12); 
        AbsDelay(250);                        
        TCN75_shutdown(TCN75_ADR);            
        TCN75_read(TCN75_ADR);      

        char tmp[16],result[32];
        int temp_low;

		temp_low = getTemperatureLow();
		if(!temp_low & 128)
			temp_low = (temp_low & 63) - 127;
	    else
			temp_low = temp_low & 63;
		temperature = temp_low + (0.0625 * (getTemperatureHigh()>>4));

        newline();
		print("Temperature: ");
	    Str_WriteFloat(temperature,4,result,0);
		Serial_WriteText(0,result);
        setCursorPosLCD(1,0);
        writeStringLCD(result);
        writeCharLCD(223);
        writeCharLCD('C');
		print("C");
        newline();

        if (temperature > 27.0) {
            setLEDs(LED3 | LED4 | LED5);

            setCursorPosLCD(1,12);
            writeCharLCD('*');
            writeCharLCD('*');
            writeCharLCD('*');
            beep(200, 50, 100);
            setLEDs(0);
            clearPosLCD(1,12,3);
            beep(200, 50, 100);
        }
        else {
            setLEDs(LED1);
            AbsDelay(250);
        }
    }
}


