//------------------------------------------------------------------------------
// Unkommentierte Version von Temperature_Thread.cc

#include "../../RP6CCLib/RP6CCLib.cc"

#define TCN75_ADR 0x90

float temperature;

void read_temperature(void)
{
	while(true) {
        Thread_Lock(1);
		TCN75_run(TCN75_ADR, TCN75A_CONFIG_RES_12);
        Thread_Lock(0);    

        Thread_Delay(25);

        Thread_Lock(1);  
        TCN75_shutdown(TCN75_ADR);
        TCN75_read(TCN75_ADR);
        Thread_Lock(0);

        char tmp[16],result[32];
        int temp_low;

		temp_low = getTemperatureLow();
		if(!temp_low & 128)
			temp_low = (temp_low & 63) - 127;
	    else
			temp_low = temp_low & 63;
		temperature = temp_low + (0.0625 * (getTemperatureHigh()>>4));

        newline();
		print("Temperature: ");
	    Str_WriteFloat(temperature,4,result,0);
		Serial_WriteText(0,result);

        Thread_Lock(1);
        setCursorPosLCD(1,0);
        writeStringLCD(result);
        writeCharLCD(223);
        writeCharLCD('C');
        Thread_Lock(0);

		print("C");
        newline();
		Thread_Delay(25);
	}
}

void main(void)
{
	RP6_CCPRO_Init(); 
	
    newline();
    println("   ________________________");
    println("   \\| RP6  ROBOT SYSTEM |/");
    println("    \\_-_-_-_-_-_-_-_-_-_/ ");
    newline();
    println("   Temperature Measurement Program  ");
    newline();

    showScreenLCD("Temp. Sensor", "DEMO Program 2");
    AbsDelay(2000);

    beep(100, 200, 300);

    showScreenLCD("Temperature:", "        ");
    Thread_Start(1,read_temperature);

    while(true)
    {
        if (temperature > 27.0) {
            Thread_Lock(1);
            setLEDs(LED3 | LED4 | LED5);
            setCursorPosLCD(1,12);
            writeCharLCD('*');
            writeCharLCD('*');
            writeCharLCD('*');
            Thread_Lock(0);
            
            beep_t(200, 5, 10);    
             
            Thread_Lock(1);
            setLEDs(0);
            clearPosLCD(1,12,3);
            Thread_Lock(0);
            
            beep_t(200, 5, 10);
        }
        else {
            Thread_Lock(1);
            setLEDs(LED1);
            Thread_Lock(0);
        }
        Thread_Delay(25);
    }
}
