/*******************************************************************************
 * RP6 C-Control PRO M128 Erweiterungsmodul
 * ----------------------------------------------------------------------------
 * I2C Bus Beispielprogramm
 * ----------------------------------------------------------------------------
 * In diesem Programm werden die LEDs auf dem Roboter Mainboard ber den
 * I2C Bus gesteuert.
 * Der aktuelle Wert der LEDs wird auch auf dem LCD angezeigt.
 *
 * Dazu muss natrlich das I2C_Slave Programm in den Controller auf
 * dem Mainboard geladen werden! Sonst wird es nicht funktionieren.
 * Das gilt natrlich auch fr ALLE nachfolgenden Beispielprogramme!
 *
 * *****************************************************************************
 * Der Roboter bewegt sich in diesem Beispielprogramm NICHT und kann
 * am Rechner angeschlossen bleiben!
 ******************************************************************************/

// WICHTIG: Immer die RP6CCLib mit einbinden:
#include "../../RP6CCLib/RP6CCLib.cc"

// I2C Bus Adresse des Controllers auf dem Mainboard:
#define RP6_BASE_ADR 10
// (die Adresse kann auch im RP6I2CSlave Programm gendert werden)

void main(void)
{
	RP6_CCPRO_Init(); // Auf Startsignal warten!

    newline();
    println("   ________________________");
    println("   \\| RP6  ROBOT SYSTEM |/");
    println("    \\_-_-_-_-_-_-_-_-_-_/ ");
    newline();
    println("  I2C Testprogram  ");
    newline();

    beep(100, 200, 300);

    showScreenLCD("I2C Testprogram", "LEDs:         ");

    byte leds;     // Aktueller LED Zustand
    byte led_test; // Zum berprfen
    leds = 1;

    char tmp[17];

    while(true)
    {
        // LEDs auf dem Roboter Mainboard setzen:
        RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SETLEDS, leds);
        AbsDelay(10);

        // Aktuellen Zustand der LEDs auslesen:
        led_test = RP6_readRegister(RP6_BASE_ADR, I2C_REG_LEDS);

        setCursorPosLCD(1,6);
        // berprfen ob die bertragung erfolgreich war
        // (das muss man normalerweise nicht machen, nur wenn
        // man sichergehen will):
        if(led_test == leds) {
            Str_WriteInt(led_test,tmp,0);
            writeStringLCD(tmp);
            printLCD("    ");
        }
        else {
            printLCD("ERROR!");
            println("I2C COMMUNICATION ERROR!");
        }

        // Nchste LED:
        leds = leds << 1;
        if(leds > 63)
            leds = 1;

        AbsDelay(250);
    }
}

