//------------------------------------------------------------------------------
// Unkommentierte Version von RP6_I2C_2.cc

#include "../../RP6CCLib/RP6CCLib.cc"

#define RP6_BASE_ADR 10

void main(void)
{
	RP6_CCPRO_Init();

    newline();
    println("   ________________________");
    println("   \\| RP6  ROBOT SYSTEM |/");
    println("    \\_-_-_-_-_-_-_-_-_-_/ ");
    newline();
    println("  I2C Testprogram ACS ");
    newline();

    beep(100, 200, 300);

    showScreenLCD("I2C-ACS-Bumper", "DEMO Program");
    AbsDelay(2000);
    clearLCD();

    RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SET_ACS_POWER, ACS_PWR_MED);
    RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SETLEDS, LED1 | LED4); 
 
    while(true)
    {
        if(Port_ReadBit(PORT_PE5_INT)) {
            Port_WriteBit(PORT_LED2, 1);

            byte status;
            status = RP6_readRegister(RP6_BASE_ADR, I2C_REG_STATUS1);

            byte bumperLeft, bumperRight;
            bumperLeft = status & 0x2;
            bumperRight = status & 0x4;

            byte leds;
            leds = 0;

            if(bumperLeft) { 
                setCursorPosLCD(0,13);
                printLCD("BL");
                leds = LED5;
            }
            else 
                clearPosLCD(0,13,2);

            if(bumperRight) {
                setCursorPosLCD(0,0);
                printLCD("BR");
                leds = leds | LED3;
            }
            else
                clearPosLCD(0,0,2);

            if(bumperLeft && bumperRight) {
                setCursorPosLCD(0,6);
                printLCD("MID");
                leds = leds | LED4;
            }
            else
                clearPosLCD(0,6,3);

            setLEDs(leds);

            byte obstacleLeft, obstacleRight;
            obstacleLeft = status & 0x20;
            obstacleRight = status & 0x40;

            byte leds_rp6;
            leds_rp6 = 0;

            if(obstacleLeft) { 
                leds_rp6 = LED6;
                setCursorPosLCD(1,11);
                printLCD("LEFT");
            }
            else {
                leds_rp6 = LED4;
                clearPosLCD(1,11,4) ;
            }

            if(obstacleRight) {
                leds_rp6 = leds_rp6 | LED3;
                setCursorPosLCD(1,0);
                printLCD("RIGHT");
            }
            else {             
                leds_rp6 = leds_rp6 | LED1;
                clearPosLCD(1,0,5);
            }

            if(obstacleRight && obstacleLeft) {
                leds_rp6 = leds_rp6 | LED2 | LED5;
                setCursorPosLCD(1,6);
                printLCD("MID");
            }
            else
                clearPosLCD(1,6,3);
                
            RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SETLEDS, leds_rp6);
        }
    }
}


