//------------------------------------------------------------------------------
// Unkommentierte Version von RP6_Sensors2.cc

#include "../../RP6CCLib/RP6CCLib.cc"

#include "RP6MasterLib.cc"

#define RANGE 25

void readLightSensors(void)
{
    getLightSensors();

    newline();
    newline();
    print(" | LSL:"); printInteger(adcLSL);
    print(" | LSR:"); printInteger(adcLSR);
    newline();

    if(adcLSL > 999)
        adcLSL = 999;
    if(adcLSR > 999)
        adcLSR = 999;

    setCursorPosLCD(1, 2);
	printIntegerLCD(adcLSL);
    setCursorPosLCD(1, 7);

    int dif, abs_dif;
    dif = (adcLSL - adcLSR);
    if(dif > 160) { dif = 160; }
    if(dif < -160) { dif = -160; }
    if(dif < 0) { abs_dif = -dif; }
    else
        abs_dif = dif;
    if(abs_dif > 30) abs_dif = 30;

    if(adcLSL < (adcLSR - RANGE)) {
        writeCharLCD('<');
        changeDirection(RIGHT);
        moveAtSpeed(abs_dif, abs_dif);
    }
    else if(adcLSR < (adcLSL - RANGE)) {
       
        writeCharLCD('>');
        changeDirection(LEFT);
        moveAtSpeed(abs_dif, abs_dif);
    }
    else { 
        writeCharLCD('='); stop();
    }

    writeCharLCD(' ');
    writeCharLCD(' ');
    printIntegerLCD(adcLSR);

    if(dif > 140)
        RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SETLEDS, 0x38);
    else if(dif > 75)
        RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SETLEDS, 0x18);
    else if(dif > 35)
        RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SETLEDS, 0x08);
    else if(dif > -35)
        RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SETLEDS, 0x09);
    else if(dif > -75)
        RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SETLEDS, 0x01);
    else if(dif > -140)
        RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SETLEDS, 0x03);
    else
        RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SETLEDS, 0x07);
}

void main(void)
{
	RP6_CCPRO_Init(); 

    newline();
    println("   ________________________");
    println("   \\| RP6  ROBOT SYSTEM |/");
    println("    \\_-_-_-_-_-_-_-_-_-_/ ");
    newline();
    println("  RP6 Sensor Reading 2 ");
    newline();

    beep(100, 200, 300);

    showScreenLCD("LIGHT SENSORS", "L             R");

    RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SETLEDS, 0x09);

    while(true)
    {
        readLightSensors();
        AbsDelay(50);
    }
}


