//------------------------------------------------------------------------------
// Unkommentierte Version von RP6_Sensorcheck.cc


#ifndef __SENSORCHECK__ 
#define __SENSORCHECK__


void handle_ACS(void)
{
    beep_t(200, 1, 1); 
    byte leds_rp6;
    leds_rp6 = 0;

    if(obstacleRight) { 
        leds_rp6 = LED3;
        setCursorPosLCD(1,11);
        printLCD("RIGHT");
    }
    else {          
        leds_rp6 = LED1;
        clearPosLCD(1,11,5) ;
    }

    if(obstacleLeft) {  
        leds_rp6 = leds_rp6 | LED6; 
        setCursorPosLCD(1,0);
        printLCD("LEFT");
    }
    else {            
        leds_rp6 = leds_rp6 | LED4;
        clearPosLCD(1,0,5);
    }
  
    if(obstacleRight && obstacleLeft) { 
        leds_rp6 = leds_rp6 | LED2 | LED5;
        setCursorPosLCD(1,6);
        printLCD("MID");
    }
    else
        clearPosLCD(1,6,3);

    RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SETLEDS, leds_rp6);
}

void handle_Bumpers(void)
{
    beep_t(100, 1, 1);
    byte leds;
    leds = 0;

    if(bumperRight) { 
        setCursorPosLCD(0,13);
        printLCD("BR");    
        leds = LED5;       
    }                      
    else 
        clearPosLCD(0,13,2);
                           
    if(bumperLeft) { 
        setCursorPosLCD(0,0);
        printLCD("BL");    
        leds = leds | LED3; 
    }                      
    else                   
        clearPosLCD(0,0,2);
                           
    if(bumperLeft && bumperRight) { 
        setCursorPosLCD(0,6);
        printLCD("MID");   
        leds = leds | LED4;
    }                      
    else                   
        clearPosLCD(0,6,3);

    setLEDs(leds);
}

void handle_BatLow(void)
{
    print("BAT LOW:");
    printInteger(adcBat);
    println(" ");
}

void handle_DriveSystemChange(void)
{
    print(" DRIVE:");
    printInteger(movementComplete);
    printInteger(motorOvercurrent);
    println(" ");
}

void handle_RC5_reception(void)
{
    beep_t((RC5_data+5)*15, 2, 2);
    print(" RC5: ");
    printInteger(RC5_toggle);
    print(":");
    printInteger(RC5_adr); 
    print(":");
    printInteger(RC5_data); 
    println(" ");
}


byte heartbeat;
void handle_WDT_RQ(void)
{
    if(heartbeat)
    {
        clearPosLCD(0, 11, 1);
        heartbeat = false;
    }
    else
    {
        setCursorPosLCD(0,11);
        printLCD("*");
        heartbeat = true;
    }
}

void thread_checkINT0(void)
{
    while(true) {
        if(Port_ReadBit(PORT_PE5_INT)) {
            Port_WriteBit(PORT_LED2, 1);

            RP6_readRegisters(RP6_BASE_ADR, 0, messageBuf, 3);
            byte compare;
            compare = messageBuf[0] ^ interrupt_status;
            interrupt_status = messageBuf[0];

            if(compare & MASK_ACS)
            {
                 obstacleLeft = messageBuf[0] & 0x20;
                 obstacleRight = messageBuf[0] & 0x40;

                 handle_ACS();
            }
            
            if(compare & MASK_BUMPER)
            {
                 bumperLeft = messageBuf[0] & 0x2;
                 bumperRight = messageBuf[0] & 0x4;

                 handle_Bumpers();
            }

            if(interrupt_status & MASK_RC5)
            {
                RP6_readRegisters(RP6_BASE_ADR, I2C_REG_RC5_ADR, messageBuf, 2);
                RC5_toggle = messageBuf[0] >> 5;
                RC5_adr = messageBuf[0] & 0x1F;
                RC5_data = messageBuf[1];

                handle_RC5_reception();
            }

            if(compare & MASK_BATLOW)
            {
                RP6_readRegisters(RP6_BASE_ADR, I2C_REG_ADC_UBAT_L, messageBuf, 2);
                adcBat = (messageBuf[1] << 8) | (messageBuf[0]);

                handle_BatLow();
            }

            if(compare & MASK_DRIVE)
            {
                 movementComplete = messageBuf[2] & 1;
                 motorOvercurrent = messageBuf[2] & 4;
                 handle_DriveSystemChange();
            }

            if(messageBuf[1] & MASK_WDT_RQ)
            {
                handle_WDT_RQ();
            }
            Port_WriteBit(PORT_LED2, 0);
        }

        Thread_Delay(1);
    }
}

#endif
