/*******************************************************************************
 * RP6 C-Control PRO M128 Erweiterungsmodul
 * ----------------------------------------------------------------------------
 * I2C Bus - Sensorik - Beispielprogramm
 * ----------------------------------------------------------------------------
 * Wie man im letzten Beispiel gesehen hat, wird das alles langsam recht
 * unbersichtlich.
 * Um das zu verbessern, lagern wir nun die ganze Interruptverwaltung in eine
 * separate Datei aus - allerdings nicht in die RP6MasterLib, sondern in eine
 * neue C Datei, RP6_Sensorcheck.cc. Weiterhin wird dort einiges weiter
 * aufgesplittet und in separate Funktionen aufgeteilt - so wird die Lesbarkeit
 * des Codes weiter verbessert.
 *
 * Ansonsten ist dieses Beispielprogramm funktional wieder identisch
 * zum Vorangegangenen.
 ******************************************************************************/


#include "../../RP6CCLib/RP6CCLib.cc"

// ###########################
// Die neue Library einbinden - ACHTUNG - diese hat sich in diesem
// Beispielprogramm gendert, da einige neue Funktionalitten hinzugekommen
// sind!
#include "RP6MasterLib.cc"


// ###########################
// Die Ausgelagerte Sensor/Interrupt Behandlung einbinden:
#include "RP6_Sensorcheck.cc"


// In diesem Beispielprogramm passiert im Hauptprogramm nicht mehr viel,
// aber das muss natrlich nicht so bleiben...

void main(void)
{
	RP6_CCPRO_Init(); // Auf Startsignal warten!

    newline();
    println("   ________________________");
    println("   \\| RP6  ROBOT SYSTEM |/");
    println("    \\_-_-_-_-_-_-_-_-_-_/ ");
    newline();
    println("  RP6 Sensor Reading 5 ");
    newline();

    beep(100, 200, 300);

    showScreenLCD("Sensors", "DEMO Program 5");
    AbsDelay(2000);
    clearLCD();

    // ACS auf mittlere Sendeleistung stellen:
    RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SET_ACS_POWER, ACS_PWR_MED);
    RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SET_WDT, true);
    RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SET_WDT_RQ, true);

    // Der Thread zur berprfung von Statusnderungen wird gestartet:
    Thread_Start(1,thread_checkINT0);

    RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SETLEDS, LED1 | LED4);
    
    while(true)
    {
        Thread_Delay(10);
    }
}


