/*******************************************************************************
 * RP6 C-Control PRO M128 Erweiterungsmodul
 * ----------------------------------------------------------------------------
 * I2C Bus - Bewegung & Sensorik - Beispielprogramm
 * ----------------------------------------------------------------------------
 * Nun soll sich der RP6 unter Verwendung der bisher bereits geschriebenen
 * Funktionen auch mal ein wenig mehr bewegen als nur auf der Stelle zu rotieren.
 * Viel mehr wird es in diesem Beispiel allerdings noch nicht, der RP6 fhrt
 * zunchst etwa 250mm vorwrts, rotiert um etwa 180 nach links,
 * fhrt wieder 250mm geradeaus, rotiert um 180 nach rechts und das in einer
 * Endlosschleife.
 *
 * Es wird der blockierende Modus der Bewegungsfunktionen verwendet.
 * Die Sensorikfunktionen aus den vorangegangenen Beispielen sind noch immer
 * in hnlicher Form vorhanden - werden aber noch *nicht* fr Ausweichmanver
 * o.. verwendet.
 * Der Zustand der Bewegungsablufe wird mit der roten LED5 angezeigt.
 * Wenn der Bewegungsablauf abgeschlossen ist, ist die LED angeschaltet.
 ******************************************************************************/


#include "../../RP6CCLib/RP6CCLib.cc"

// ###########################
#include "RP6MasterLib.cc"

// ###########################
#include "RP6_Sensorcheck.cc"


void main(void)
{
	RP6_CCPRO_Init(); // Auf Startsignal warten!

    newline();
    println("   ________________________");
    println("   \\| RP6  ROBOT SYSTEM |/");
    println("    \\_-_-_-_-_-_-_-_-_-_/ ");
    newline();
    println("  RP6 Movement DEMO 1 ");
    newline();

    beep(100, 200, 300);

    showScreenLCD("Movement", "DEMO Program 1");
    AbsDelay(2000);
    clearLCD();

    // ACS auf mittlere Sendeleistung stellen:
    RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SET_ACS_POWER, ACS_PWR_MED);
    RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SET_WDT, true);
    RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SET_WDT_RQ, true);

    // Der Thread zur berprfung von Statusnderungen wird gestartet:
    Thread_Start(1,thread_checkINT0);

    while(true)
    {
        setRP6LEDs(LED3 | LED6);
        RP6_move_mm(70,FWD,250,BLOCKING);  // 250mm geradeaus fahren
        setRP6LEDs(LED3 | LED4);
        RP6_rotate(80,LEFT,180,BLOCKING);  // um 180 nach links drehen
        setRP6LEDs(LED3 | LED6);
        RP6_move_mm(70,FWD,250,BLOCKING);  // 250mm geradeaus fahren
        setRP6LEDs(LED1 | LED6);
        RP6_rotate(80,RIGHT,180,BLOCKING);  // um 180 nach rechts drehen
    }
}


