//------------------------------------------------------------------------------
// Unkommentierte Version von RP6_Movement4.cc

#include "../../RP6CCLib/RP6CCLib.cc"

#include "RP6MasterLib.cc"

#include "RP6_Sensorcheck.cc"

#define THREAD_CHECK_INT0         1
#define THREAD_CHECK_BUMPERS      2
#define THREAD_BLINK              3
#define THREAD_MOVE_RECT          4

void blink(void)
{
    while(true)
    {
        setRP6LEDs(LED2 | LED3);
        setLEDs(LED3 | LED4 | LED5);
        Thread_Delay(5);
        setLEDs(0);
        Thread_Delay(30);
        setRP6LEDs(LED5 | LED6);
        setLEDs(LED3 | LED4 | LED5);
        Thread_Delay(5);
        setLEDs(0);
        Thread_Delay(30);
    }
}

void check_bumpers(void)
{
    byte stopped;
    stopped = false;

    while(true)
    {
        if(!stopped) {
        
            if(bumperLeft || bumperRight)
            {
                Thread_Kill(THREAD_MOVE_RECT); 
                stop();

                Thread_Start(THREAD_BLINK,blink);
                stopped = true; 
                setCursorPosLCD(1,0);
                printLCD("Ouch! Crash! :-(");
            }
        }
        Thread_Delay(1);
    }
}

#define MOVE_SPEED 50
#define TURN_SPEED 40

void move_rect(void)
{

    byte move_count; 
    byte turn_direction;

    move_count = 0;
    turn_direction = LEFT;

    while(true)
    {
        setRP6LEDs(LED3 | LED6);

		RP6_move_mm(MOVE_SPEED, FWD, 300, BLOCKING);

        if(turn_direction==LEFT)
        {
            setRP6LEDs(LED3 | LED4);
        }
        else
        {
            if(turn_direction==RIGHT)
                setRP6LEDs(LED1 | LED6);
        }

		RP6_rotate(TURN_SPEED, turn_direction, 90, BLOCKING);

		if(move_count >= 3) 
		{
            setRP6LEDs(LED1 | LED3 | LED4 | LED6);
			Thread_Delay(100);

            if(turn_direction==LEFT)
            {
                setRP6LEDs(LED3 | LED4);
            }
            else
            {
                if(turn_direction==RIGHT)
                    setRP6LEDs(LED1 | LED6);
            }

			RP6_rotate(TURN_SPEED, turn_direction, 90, BLOCKING);

			if(turn_direction == LEFT)
				turn_direction = RIGHT;
			else
				turn_direction = LEFT;

			move_count = 0;
		}
		else 
			move_count++;
    }
}

void main(void)
{
	RP6_CCPRO_Init();

    newline();
    println("   ________________________");
    println("   \\| RP6  ROBOT SYSTEM |/");
    println("    \\_-_-_-_-_-_-_-_-_-_/ ");
    newline();
    println("  RP6 Movement DEMO 4 ");
    newline();

    beep(100, 200, 300);

    showScreenLCD("Movement", "DEMO Program 4");
    AbsDelay(2000);
    clearLCD();

    RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SET_ACS_POWER, ACS_PWR_MED);
    RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SET_WDT, true);
    RP6_writeCMD_1param(RP6_BASE_ADR, CMD_SET_WDT_RQ, true);

    Thread_Start(THREAD_CHECK_INT0,thread_checkINT0);

    Thread_Start(THREAD_CHECK_BUMPERS,check_bumpers);

    setCursorPosLCD(1,0);
    printLCD("Moving...    :-)");

    Thread_Start(THREAD_MOVE_RECT,move_rect);

    while(true)
    {
        Thread_Delay(1);
    }
}


